/* rexx for os/2, open-and-free-source-ware */
/* replace_umlaute   author:Ilja Kaufmann, TeamOS/2 Franken, kiwi@...perelin.de  (remove three dots from email) */
/* scanns a directory structure for dir-/file-names containing german umlaute */
/* and replaces them  -ae  -oe  -ue  -Oe  -Ae  -Ue  -sz  */

parse arg dirname

if right(dirname,1)='\' then dirname=left(dirname,length(dirname)-1)
dirname=checkdir(dirname)'\'
say dirname
dirname_l=length(dirname)

Call rxfuncadd 'SysFileTree', 'RexxUtil', 'SysFileTree'
Call rxfuncadd 'SysGetEA', 'RexxUtil', 'SysGetEA'
Call rxfuncadd 'SysPutEA', 'RexxUtil', 'SysPutEA'

call SysFileTree dirname, 'alle', 'SO'

if alle.0=0 then do
   say 'nothing to do ---> exiting'
   exit
end  /* Do */


if alle.0>1 then do
  do i=1 to alle.0-1
    found=i
    do j=i+1 to alle.0
      if alle.j<alle.found then found=j
    end /* do */
    merken=alle.i
    alle.i=alle.found
    alle.found=merken
  end /* do */
end /* if */


do i=1 to alle.0
  neue.i=replaceall('',alle.i,'oe',dirname_l)
  neue.i=replaceall('',neue.i,'ae',dirname_l)
  neue.i=replaceall('',neue.i,'ue',dirname_l)
  neue.i=replaceall('',neue.i,'Oe',dirname_l)
  neue.i=replaceall('',neue.i,'Ae',dirname_l)
  neue.i=replaceall('',neue.i,'Ue',dirname_l)
  neue.i=replaceall('',neue.i,'sz',dirname_l)
  /* say alle.i'--'neue.i */

end /* do */

say ' '

do i=1 to alle.0
  if alle.i<>neue.i then do
     if i<alle.0 then do
       do j=i+1 to alle.0
          alle.j=replaceall(alle.i,alle.j,neue.i)
       end /* do */
     end  /* Do */

     neu=substr(neue.i,pos('\',neue.i))

     /* say 'move "'alle.i'" "'neu'"'                                                  */
     /* say 'SysPutEA('neue.i',".longname","'substr(neue.i,lastpos('\',neue.i)+1)'")'  */

     'move "'alle.i'" "'neu'"'
     rc=SysPutEA(neue.i,".longname",substr(neue.i,lastpos('\',neue.i)+1))

     /* if SysGetEA(alle.i,'.longname','langername')=0 then do */
     /*   parse var langername 5 langername                    */
     /*   say alle.i' objektname:'langername                   */
     /* end  /* Do */                                          */


  end  /* Do */
end /* do */


exit



/* routine um alle 'such' in der variable 'in' durch den ausdruck 'durch' zu ersetzen */

replaceall:
  parse arg such,in,durch,ab
  if ab="" then ab=1
  such_l=length(such)
  durch_l=length(durch)
  ipos=pos(such,in,ab)
  do while ipos>0
    in=substr(in,1,ipos-1)''durch''substr(in,ipos+such_l)
    ipos=pos(such,in,ipos+durch_l)
  end  /* while */
return in;

/* routine die checkt, ob ein gewnschtes directory existiert und dessen korrekten namen zurckgibt */

checkdir:
  parse arg zutesten
  akt_d=directory()
  neu_d=directory(zutesten)
  if neu_d="" then do
     say "Directory '"zutesten"' not found"
     say "press return to exit"
     pull a
     exit
  end  /* if */
  rc=directory(akt_d)
return neu_d;


